// CommPort.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "CommPort.h"

//----------------------------------------------------------------
//๹캯
 CCommPort::CCommPort()
{
  hComm          = 0;
  m_eEvent         = EEventNone;
  m_hevtOverlapped = 0;
  lpszPort="COM1";		//ʼ
  eBaudrates=EBaud9600;		//ʼ
  nFrameHead=0x12;
  nTimePerByte=1;
}
//---------------------------------------------------------------
//
 CCommPort::~CCommPort ()
{
  Flush();

  if (hComm)
	ClosePort();
}
//---------------------------------------------------------------------------
//      ú
//ڲʡλУλֹͣλ
//ܣ
//        һò
//        λ
//        ýλ
//        ġֹͣλ
//ֵóɹֵΪ0ʧܷʧ
//--------------------------------------------------------------------------
int  CCommPort::Setup (EBaudrate eBaudrate, EDataBits eDataBits, EParity eParity, EStopBits eStopBits)
{
	if (hComm ==0)
		return 102;	//ʱδ

	ZeroMemory(&m_dcb, sizeof (DCB));
	m_dcb.DCBlength	= sizeof (DCB);
	m_dcb.BaudRate = DWORD(eBaudrate);
	m_dcb.ByteSize = BYTE(eDataBits);
	m_dcb.Parity   = BYTE(eParity);
	m_dcb.StopBits = BYTE(eStopBits);
	m_dcb.fParity  = (eParity != EParNone);

	m_dcb.fBinary = 1;
	m_dcb.fDtrControl = 0;
	m_dcb.fRtsControl = 0;
	m_dcb.XonLim = 2048;
	m_dcb.XoffLim = 512;

	m_dcb.XonChar = 17;
	m_dcb.XoffChar = 19;

	if (!::SetCommState(hComm,&m_dcb))	//DCBṹ
		return 202;
	return 0;
}
//-----------------------------------------------------------
//      ʱú
//ڲʱ
//ܣ
//        ʱ
//-----------------------------------------------------------
int  CCommPort::SetupReadTimeouts (int nBlockRead)
{
  if (hComm == 0)
        return 102;
  COMMTIMEOUTS cto;
  if (!::GetCommTimeouts(hComm,&cto))
        return 203;	//ܻóʱṹ

  //óʱṹ
  if(!nBlockRead){
          cto.ReadIntervalTimeout = 0;
          cto.ReadTotalTimeoutConstant = 0;
          cto.ReadTotalTimeoutMultiplier =0;
  }else{
          cto.ReadIntervalTimeout = 0;
          cto.ReadTotalTimeoutConstant = 0;
          cto.ReadTotalTimeoutMultiplier =nBlockRead;
  }

  if (!::SetCommTimeouts(hComm,&cto))
        return 204;	//óʱṹ
  return 0;
}


//-----------------------------------------------------------------------------
//      дں
//ڲдݻַдݳȡ
//-----------------------------------------------------------------------------
int  CCommPort::Write ( BYTE* pData, size_t iLen, DWORD* pdwWritten, LPOVERLAPPED lpOverlapped, DWORD dwTimeout)
{
  DWORD dwWritten;
  if (pdwWritten == 0)
  	pdwWritten = &dwWritten;
  *pdwWritten = 0;

  if (hComm == 0)
	return 102;	//ʱδ

  OVERLAPPED ovInternal;
  if (lpOverlapped == 0){
	memset(&ovInternal,0,sizeof(ovInternal));
	ovInternal.hEvent = m_hevtOverlapped;
	lpOverlapped = &ovInternal;
  }

  if (!::WriteFile(hComm,pData,iLen,pdwWritten,lpOverlapped)){

	long lLastError = ::GetLastError();
	if (lLastError != ERROR_IO_PENDING)
			return 104;	//дڳ

 	if (lpOverlapped == &ovInternal){
		switch (::WaitForSingleObject(lpOverlapped->hEvent,dwTimeout)){

			case WAIT_OBJECT_0:
				if (!::GetOverlappedResult(hComm,lpOverlapped,pdwWritten,FALSE))
					return 104;	//дڳ
				break;
			case WAIT_TIMEOUT:
				::CancelIo(hComm);
				return 104;	//ڳ
			default:
				return 104;	//ڳ
                }
        }
  }

  return 0;
}

//---------------------------------------------------------------------
//      ں
//ڲݴŵַݳ
//----------------------------------------------------------------------
int  CCommPort::Read (BYTE* pData, size_t iLen, DWORD* pdwRead, LPOVERLAPPED lpOverlapped, DWORD dwTimeout)
{
  DWORD dwRead;
  if (pdwRead == 0)
	pdwRead = &dwRead;
  *pdwRead = 0;

  if (hComm == 0)
        return 102;	//ʱѴ

  OVERLAPPED ovInternal;
  if (lpOverlapped == 0){
  	memset(&ovInternal,0,sizeof(ovInternal));
        ovInternal.hEvent = m_hevtOverlapped;
	lpOverlapped = &ovInternal;
  }

  if(!ReadFile(hComm,pData,iLen,pdwRead,lpOverlapped)){
  	long lLastError = ::GetLastError();
  	if (lLastError != ERROR_IO_PENDING)
		return 1031;	//ʧ

  	if (lpOverlapped == &ovInternal){
		switch (::WaitForSingleObject(lpOverlapped->hEvent,dwTimeout)){

			case WAIT_OBJECT_0:
                                {
				if (!::GetOverlappedResult(hComm,lpOverlapped,pdwRead,TRUE))
					return 1032;	//ʧ
                                }
				break;

			case WAIT_TIMEOUT:
				::CancelIo(hComm);
				return 1033;	//ʧ

			default:
				return 1034;	//ʧ
                }
        }
  }

  return 0;
}

//-------------------------------------------------------------------------------
//      ͨ¼
//ܣͨ¼
//ڲ    dwMask  Ҫõ¼
//ֵɹʱֵΪ0ʧܺ󣬷ʧ
//-----------------------------------------------------------------------------
int  CCommPort::SetMask (DWORD dwMask)
{
  if (hComm == 0)
        return 102;	//ʱû
  if (!::SetCommMask(hComm,EEventRecv))
        return 208;	//¼
  return 0;
}
//-----------------------------------------------------------------------------

//      
//ܣǰѽյݻ͵
//ڲ    
//ֵɹʱֵΪ0ʧܺ󣬷ʧ
//-----------------------------------------------------------------------------
int  CCommPort::Flush()
{
  if (hComm == 0)
        return 102;	//ʱû
  if (!::PurgeComm(hComm, PURGE_RXCLEAR|PURGE_TXCLEAR|PURGE_TXABORT|PURGE_RXABORT))
        return 207;	//
  return 0;
}

//-------------------------------------------------------------------------------
int   CCommPort::WaitEvent (BYTE* pAckBuff,int nTimeOuts)
{
  COMSTAT     ComStat;
  DWORD       dwErrorFlags;

  DWORD       dwEvtMask,dwTrans ;
  OVERLAPPED  os ;

  memset( &os, 0, sizeof( OVERLAPPED ) ) ;

  os.hEvent = CreateEvent( NULL,    // no security
		TRUE,    // explicit reset req
		FALSE,   // initial event reset
		NULL ) ; // no name

  if (os.hEvent == NULL)
   	return 1;
  
  SetMask();

  dwEvtMask=0;
  if(!WaitCommEvent(hComm, &dwEvtMask, &os)){        // ص

     	if(GetLastError()==ERROR_IO_PENDING){
                // ޵ȴص
		// GetOverlappedResult(hComm, &os, &dwTrans, true);
		switch (::WaitForSingleObject(os.hEvent,nTimeOuts)){
			case WAIT_OBJECT_0:
				if (!::GetOverlappedResult(hComm,&os, &dwTrans, TRUE))
					return 209;	//Ӵڳ
				break;

			case WAIT_TIMEOUT:
                                ClearCommError(hComm,&dwErrorFlags,&ComStat);
                                if(ComStat.cbInQue == 0){
                                        ::CancelIo(hComm);
                                        return 209;	//Ӵڳ
                                }
			default:
				return 209;	//Ӵڳ
		}
	}else
	   	return 209;	//Ӵڳ
  }//else
   	//return 0;

   CloseHandle(os.hEvent);

  int nThreshold=0;
  int CommEro=0;
  BYTE         StartBuff=0x0;
  while(StartBuff!=nFrameHead && nThreshold<3){
       CommEro=Read(&StartBuff,1,0,0,300);
	nThreshold++;
	if(CommEro)
		return 1;
   }

  pAckBuff [0]=StartBuff;

  BYTE OrdAndLenBuff[4]={0x0};

  int nAndBgn=nFrameHead & 0xC0;
  int nAlreadyRead=0;
  int nFrameLen=0;
  
        //жϽճ
  switch(nAndBgn){
        case 0x0: //볤Ϊ1Ϊ1ʱ
                CommEro=Read(OrdAndLenBuff,2,0,0,nTimeOuts);
                if(CommEro)
                        return CommEro;
                pAckBuff[1]=OrdAndLenBuff[0];
                pAckBuff[2]=OrdAndLenBuff[1];
                nFrameLen=OrdAndLenBuff[1];
                nAlreadyRead=3;
                break;
        case 0x40: //볤Ϊ1Ϊ2ʱ
                CommEro=Read(OrdAndLenBuff,3,0,0,nTimeOuts);
                if(CommEro)
                        return CommEro;
                pAckBuff[1]=OrdAndLenBuff[0];
                pAckBuff[2]=OrdAndLenBuff[1];
                pAckBuff[3]=OrdAndLenBuff[2];
                nFrameLen=OrdAndLenBuff[1]*256+OrdAndLenBuff[2];
                nAlreadyRead=4;
                break;
        case 0x80: //볤Ϊ2Ϊ1ʱ
                CommEro=Read(OrdAndLenBuff,3,0,0,nTimeOuts);
                if(CommEro)
                        return CommEro;
                pAckBuff[1]=OrdAndLenBuff[0];
                pAckBuff[2]=OrdAndLenBuff[1];
                pAckBuff[3]=OrdAndLenBuff[2];
                nFrameLen=OrdAndLenBuff[1];
                nAlreadyRead=4;
                break;
        case 0xC0: //볤Ϊ2Ϊ2ʱ
                CommEro=Read(OrdAndLenBuff,4,0,0,nTimeOuts);
                if(CommEro)
                        return CommEro;
                pAckBuff[1]=OrdAndLenBuff[0];
                pAckBuff[2]=OrdAndLenBuff[1];
                pAckBuff[3]=OrdAndLenBuff[2];
                pAckBuff[4]=OrdAndLenBuff[3];
                nFrameLen=OrdAndLenBuff[2]*256+OrdAndLenBuff[3];
                nAlreadyRead=5;
                break;
        }


  BYTE *LeaveBuff;
  LeaveBuff=new BYTE[nFrameLen];

  CommEro=Read(LeaveBuff,nFrameLen,0,0,nTimeOuts);
    if(CommEro)
        return CommEro;
  for(int i=0;i<nFrameLen;i++)
        pAckBuff[i+nAlreadyRead]=LeaveBuff[i];


  //
  SetCommMask(hComm,0);
  return 0;
}
//-------------------------------------------------------------------------------
//      ֡ͷ
//ܣͨʱ/Ӧ֡֡ͷ
//ڲ    nHead  ֡ͷֵΪ0-255֮
//                       0<=nHead<0x40 ʱ    ֡1ֽڱʾַ1ֽڱʾ
//                       0x40<=nHead<0x80 ʱ ֡2ֽڱʾַ1ֽڱʾ
//                       0x80<=nHead<0xC0 ʱ ֡1ֽڱʾַ2ֽڱʾ
//                       0xC0<=nHead<=0xFF ʱ֡1ֽڱʾַ1ֽڱʾ
//ֵóɹ󣬷ֵΪTRUE; 򷵻ֵΪFALSE
//-----------------------------------------------------------------------------

BOOL   CCommPort::SetFrameHead(int nHead)
{
 if(nHead>256||nHead<0)
        return FALSE;
 nFrameHead=nHead;
 return TRUE;
}

//-----------------------------------------------------------------------------

//	ôںź
//ܣѡҪ򿪵Ĵں
//ڲ    ePort  ںţ1-4COM1-COM4,ֵ.
//ֵɹ󣬷ֵΪTRUE, Ϊ FALSE
//-----------------------------------------------------------------------------
BOOL  CCommPort::SetCommPort(int ePort)
{
  switch(ePort){
        case 1:
                lpszPort="COM1";
                break;
        case 2:
                lpszPort="COM2";
                break;
        case 3:
                lpszPort="COM3";
                break;
        case 4:
                lpszPort="COM4";
                break;
        case 5:
                lpszPort="COM5";
                break;
        case 6:
                lpszPort="COM6";
                break;
        default:
                lpszPort="COM1";
                return FALSE;
  }
  return TRUE;
}
//-----------------------------------------------------------------------------
//	ͨŲʺ
//ܣͨŹʹõĲ
//ڲ    eBaud  ֵ96009600bit/s
//ֵɹ󣬷ֵΪTRUE, Ϊ FALSE
//-----------------------------------------------------------------------------

BOOL CCommPort::SetCommBaud(int eBaud)
{
  switch(eBaud){
        case 110:
                eBaudrates=EBaud110;
                break;
        case 300:
                eBaudrates=EBaud300;
                break;
        case 600:
                eBaudrates=EBaud600;
                break;
        case 1200:
                eBaudrates=EBaud1200;
                break;
        case 2400:
                eBaudrates=EBaud2400;
                break;
        case 4800:
                eBaudrates=EBaud4800;
                break;
        case 9600:
                eBaudrates=EBaud9600;
                break;
        case 14400:
                eBaudrates=EBaud14400;
                break;
        case 19200:
                eBaudrates=EBaud19200;
                break;
        case 38400:
                eBaudrates=EBaud38400;
                break;
        case 56000:
                eBaudrates=EBaud56000;
                break;
        case 57600:
                eBaudrates=EBaud57600;
                break;
        case 115200:
                eBaudrates=EBaud115200;
                break;
        default:
                eBaudrates=EBaud9600;
                return FALSE;
	}
  nTimePerByte=10000/eBaud;
  nTimePerByte+=1;
  return TRUE;
}
//------------------------------------------------------------------
//      ڴ򿪺
//ܣ
//         1򿪴
//         2öдú
//         3ôڴú
//         4óʱú
//ڲ    
//ֵɹ󣬷ֵΪ0򷵻ʧ
//-----------------------------------------------------------------------------
int  CCommPort::OpenPort (int nDataBit,int nStopBit,int nParity)
{
  if (hComm)
        return 102;	//ʱѴ
  hComm = ::CreateFile(lpszPort,
		GENERIC_READ|GENERIC_WRITE,
		0,
		0,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL|FILE_FLAG_OVERLAPPED,
		0);
  if (hComm == INVALID_HANDLE_VALUE){
        hComm = 0;
        return 101;	//ܴ򿪴
  }

  m_hevtOverlapped = ::CreateEvent(0,true,false,0);
 if (m_hevtOverlapped == 0){
		::CloseHandle(hComm);
		hComm = 0;
		return 200;
  }
  
  
  if (!::SetupComm(hComm,1024*64,1024*64)){
		ClosePort();
		return 205;	//շ
	}
  if(nDataBit<5||nDataBit>8)
        nDataBit=8;

  Setup(eBaudrates ,
        EDataBits(nDataBit),
        EParity(nParity),
        EStopBits(nStopBit)
  );

  SetupReadTimeouts(0);
  return 0;
  
}
//-----------------------------------------------------------------------------
//رմں
//----------------------------------------------------------------------------
//bR: ǷDTRRTS
void  CCommPort::ClosePort (BOOL bR)
{
  if (hComm == 0)
	return ;
  if(bR){
        ClrDTR();
        ClrRTS();
  }

  ::CloseHandle(m_hevtOverlapped);
  m_hevtOverlapped = 0;

  ::CloseHandle(hComm);
  hComm = 0;
}

//-----------------------------------------------------------------------------
//      
//ܣPCƬУȡƬصӦźš
//ڲ    pOrderBuff - ָ
//   		pAckBuff - Ӧָ
//		dwTimeOuts - ȴӦϢʱĳʱʱ
//ֵɹ󣬷ֵΪ0; ʧܺ󣬷Ӧ
//-----------------------------------------------------------------------------

 int   CCommPort::SendOrder(BYTE* pOrderBuff,BYTE* pAckBuff,int nTimeOuts)
{
  int nWaitTime=nTimePerByte;           //öڳʱϵ
  int nAndBgn=nFrameHead & 0xC0;
  int nLen;
  COMSTAT     ComStat;
  DWORD       dwErrorFlags;

  SetupReadTimeouts(20);
  
  //жϴ֡
  switch(nAndBgn){
        case 0x0: //볤Ϊ1Ϊ1ʱ
                nLen=3+pOrderBuff[2];
                break;
        case 0x40: //볤Ϊ1Ϊ2ʱ
                nLen=4+pOrderBuff[2]*256+pOrderBuff[3];
                break;
        case 0x80: //볤Ϊ2Ϊ1ʱ
                nLen=4+pOrderBuff[3];
                break;
        case 0xC0: //볤Ϊ2Ϊ2ʱ
                nLen=5+pOrderBuff[3]*256+pOrderBuff[4];
                break;
  }

  
  if (!hComm)
		return 102;	//ʱδ
  
  int CommEro=0;
  Flush();
//
  CommEro=Write (pOrderBuff,nLen,0,0,nWaitTime*nLen);
  if(CommEro)
        return CommEro;

  //ȻӦ
  ClearCommError(hComm,&dwErrorFlags,&ComStat);
  if(ComStat.cbInQue == 0){
        CommEro=WaitEvent(pAckBuff,nTimeOuts);
  }else{
        int nThreshold=0;
        int CommEro=0;
        BYTE         StartBuff=0x0;
        while(StartBuff!=nFrameHead && nThreshold<3){
             CommEro=Read(&StartBuff,1,0,0,300);
              nThreshold++;
              if(CommEro)
                      return 1;
         }

        pAckBuff [0]=StartBuff;

        BYTE OrdAndLenBuff[4]={0x0};

        int nAndBgn=nFrameHead & 0xC0;
        int nAlreadyRead=0;
        int nFrameLen=0;
  
              //жϽճ
        switch(nAndBgn){
              case 0x0: //볤Ϊ1Ϊ1ʱ
                      CommEro=Read(OrdAndLenBuff,2,0,0,nTimeOuts);
                      if(CommEro)
                              return CommEro;
                      pAckBuff[1]=OrdAndLenBuff[0];
                      pAckBuff[2]=OrdAndLenBuff[1];
                      nFrameLen=OrdAndLenBuff[1];
                      nAlreadyRead=3;
                      break;
              case 0x40: //볤Ϊ1Ϊ2ʱ
                      CommEro=Read(OrdAndLenBuff,3,0,0,nTimeOuts);
                      if(CommEro)
                              return CommEro;
                      pAckBuff[1]=OrdAndLenBuff[0];
                      pAckBuff[2]=OrdAndLenBuff[1];
                      pAckBuff[3]=OrdAndLenBuff[2];
                      nFrameLen=OrdAndLenBuff[1]*256+OrdAndLenBuff[2];
                      nAlreadyRead=4;
                      break;
              case 0x80: //볤Ϊ2Ϊ1ʱ
                      CommEro=Read(OrdAndLenBuff,3,0,0,nTimeOuts);
                      if(CommEro)
                              return CommEro;
                      pAckBuff[1]=OrdAndLenBuff[0];
                      pAckBuff[2]=OrdAndLenBuff[1];
                      pAckBuff[3]=OrdAndLenBuff[2];
                      nFrameLen=OrdAndLenBuff[1];
                      nAlreadyRead=4;
                      break;
              case 0xC0: //볤Ϊ2Ϊ2ʱ
                      CommEro=Read(OrdAndLenBuff,4,0,0,nTimeOuts);
                      if(CommEro)
                              return CommEro;
                      pAckBuff[1]=OrdAndLenBuff[0];
                      pAckBuff[2]=OrdAndLenBuff[1];
                      pAckBuff[3]=OrdAndLenBuff[2];
                      pAckBuff[4]=OrdAndLenBuff[3];
                      nFrameLen=OrdAndLenBuff[2]*256+OrdAndLenBuff[3];
                      nAlreadyRead=5;
                      break;
              }


        BYTE *LeaveBuff;
        LeaveBuff=new BYTE[nFrameLen];

        CommEro=Read(LeaveBuff,nFrameLen,0,0,nTimeOuts);
          if(CommEro)
              return CommEro;
        for(int i=0;i<nFrameLen;i++)
              pAckBuff[i+nAlreadyRead]=LeaveBuff[i];
  }
  return CommEro;


}
//---------------------------------------------------------------------------

int CCommPort::SendData(BYTE* pOrderBuff,BYTE* pAckBuff,int nSendLen,int nTimeOuts,
                                        int nRcv,BYTE cEnd,BOOL bIfRcv)
{
  int nWaitTime=nTimePerByte;           //öڳʱϵ
  if (!hComm)
		return 102;	//ʱδ

  int CommEro=0;
  Flush();
  SetupReadTimeouts(nTimeOuts/nRcv+1);

  //
  CommEro=Write(pOrderBuff,nSendLen,0,0,nWaitTime*nSendLen*100);
  if(CommEro)
        return CommEro;

  if(!bIfRcv)
        return 0;
  if(nTimeOuts<=0)
        return 333;     //ûò

  if(nRcv>0)
        CommEro=Wait_Cnt(pAckBuff,nTimeOuts,nRcv);
  else
        CommEro=Wait_Byte(pAckBuff,nTimeOuts,cEnd);

  return CommEro;

}
//---------------------------------------------------------------------------
int CCommPort::Wait_Cnt(BYTE* Buff,int nTimeOuts,int nRcvCnt)
{
  int CommEro;
/*
  BYTE byRcv;
  for(int i=0;i<nRcvCnt;i++){
        CommEro=Read(&byRcv,1,0,0,nTimeOuts/nRcvCnt+1);
        if(!CommEro)
                Buff[i]=byRcv;
        else
                break;
 }
*/
  CommEro=Read(Buff,nRcvCnt,0,0,nTimeOuts);
  if(CommEro)
        return CommEro;
  return 0;
}
//----------------------------------------------------------------------------

int CCommPort::Wait_Byte(BYTE* Buff,int nTimeOuts,BYTE cEndByte)
{
  DWORD       dwEvtMask,dwTrans ;
  OVERLAPPED  os ;
  memset( &os, 0, sizeof( OVERLAPPED ) ) ;
  os.hEvent = CreateEvent( NULL,    // no security
		TRUE,    // explicit reset req
		FALSE,   // initial event reset
		NULL ) ; // no name

  if (os.hEvent == NULL)
   	return 1;

  SetMask();
  dwEvtMask=0;
  if(!WaitCommEvent(hComm, &dwEvtMask, &os)){        // ص

     	if(GetLastError()==ERROR_IO_PENDING){
                // ޵ȴص
		// GetOverlappedResult(hComm, &os, &dwTrans, true);
		switch (::WaitForSingleObject(os.hEvent,nTimeOuts)){
			case WAIT_OBJECT_0:
				if (!::GetOverlappedResult(hComm,&os, &dwTrans, TRUE))
					return 209;	//Ӵڳ
				break;

			case WAIT_TIMEOUT:
				::CancelIo(hComm);
				return 209;	//Ӵڳ

			default:
				return 209;	//Ӵڳ
		}
	}else
	   	return 209;	//Ӵڳ
  }

  CloseHandle(os.hEvent);
  //
  SetCommMask(hComm,0);


  int CommEro=0;
  BYTE  EndBuff=0x0;
  int nCurrentCnt=0;
  int nCurrentWaitTime=nTimeOuts;

  while(EndBuff!=cEndByte){
       CommEro=Read(&EndBuff,1,0,0,nCurrentWaitTime);
       Buff[nCurrentCnt]=EndBuff;
       nCurrentCnt++;
       nCurrentWaitTime=nCurrentWaitTime/nCurrentCnt+100;
       if(CommEro)
		return CommEro;
   }
  return 0;
}
//----------------------------------------------------------------------------
//ڻжȡһ
int CCommPort::ReadBlock(BYTE* pBuff,int nLen,int nTimeOuts)
{
  SetupReadTimeouts(0);
  COMSTAT     ComStat;
  DWORD       dwErrorFlags;
  ClearCommError(hComm,&dwErrorFlags,&ComStat);

  if(ComStat.cbInQue)
        return(Read(pBuff,nLen,0,0,nTimeOuts));

  DWORD       dwEvtMask,dwTrans ;
  OVERLAPPED  os ;

  memset( &os, 0, sizeof( OVERLAPPED ) ) ;

  os.hEvent = CreateEvent( NULL,    // no security
		TRUE,    // explicit reset req
		FALSE,   // initial event reset
		NULL ) ; // no name

  if (os.hEvent == NULL)
   	return 1;

  SetMask();

  dwEvtMask=0;
  if(!WaitCommEvent(hComm, &dwEvtMask, &os)){        // ص

     	if(GetLastError()==ERROR_IO_PENDING){
                // ޵ȴص
		// GetOverlappedResult(hComm, &os, &dwTrans, true);
		switch (::WaitForSingleObject(os.hEvent,nTimeOuts)){
			case WAIT_OBJECT_0:
				if (!::GetOverlappedResult(hComm,&os, &dwTrans, TRUE))
					return 209;	//Ӵڳ
				break;

			case WAIT_TIMEOUT:
				::CancelIo(hComm);
				return 209;	//Ӵڳ

			default:
				return 209;	//Ӵڳ
		}
	}else
	   	return 209;	//Ӵڳ
  }

  CloseHandle(os.hEvent);
    //
  SetCommMask(hComm,0);
  return(Read(pBuff,nLen,0,0,nTimeOuts));

}
//----------------------------------------------------------------------------

HANDLE CCommPort::GetCommHandle()
{
  return hComm;
}
//----------------------------------------------------------------------------

BOOL CCommPort::SetDTR()
{
  if (hComm == 0)
        return FALSE;	//ʱû
  return(EscapeCommFunction(hComm,SETDTR));
}
//----------------------------------------------------------------------------

BOOL CCommPort::ClrDTR()
{
  if (hComm == 0)
        return FALSE;	//ʱû
  return(EscapeCommFunction(hComm,CLRDTR));

}
//----------------------------------------------------------------------------

BOOL CCommPort::SetRTS()
{
  if (hComm == 0)
        return FALSE;	//ʱû
  return(EscapeCommFunction(hComm,SETRTS));

}
//----------------------------------------------------------------------------

BOOL CCommPort::ClrRTS()
{
  if (hComm == 0)
        return FALSE;	//ʱû

  return(EscapeCommFunction(hComm,CLRRTS));

}
//----------------------------------------------------------------------------

int CCommPort::CommWatch(int &nLen,BYTE* pBuff)
{
  DWORD       dwErrorFlags;
  COMSTAT     ComStat;
  ClearCommError(hComm,&dwErrorFlags,&ComStat);
  nLen=ComStat.cbInQue;
  if(nLen>0)
          return(Read(pBuff,nLen,0,0,10*nLen));
  return 0;

}


