

// This class is exported from the CommPort.dll
class CCommPort {
public:
 	  CCommPort();
 	  ~CCommPort();
public:
        //¼
	typedef enum
	{
		EEventNone  = -1,		// δ¼
		EEventBreak = EV_BREAK,		// ⵽ֹ
		EEventCTS   = EV_CTS,		// CTS
		EEventDSR   = EV_DSR,		// DSR
		EEventError = EV_ERR,		// ·״̬
		EEventRing  = EV_RING,		// ⵽
		EEventRLSD  = EV_RLSD,		// RLSDźŸı״̬
		EEventRecv  = EV_RXCHAR,	// յһַ뻺
		EEventRcvEv = EV_RXFLAG,	// յ¼ַ
		EEventSend  = EV_TXEMPTY,	// һַͳȥ
	}
	EEvent;



	// 
	typedef enum
	{
		EBaudUnknown = -1,		 //δ֪
		EBaud110     = CBR_110,		// 110 bits/s
		EBaud300     = CBR_300,		// 300 bits/s
		EBaud600     = CBR_600,		// 600 bits/s
		EBaud1200    = CBR_1200,	// 1200 bits/
		EBaud2400    = CBR_2400,	// 2400 bits/s
		EBaud4800    = CBR_4800,	// 4800 bits/s
		EBaud9600    = CBR_9600,	// 9600 bits/s
		EBaud14400   = CBR_14400,	// 14400 bits/s
                EBaud19200   = CBR_19200,	// 19200 bits/sec
		EBaud38400   = CBR_38400,	// 38400 bits/sec
		EBaud56000   = CBR_56000,	// 56000 bits/sec
		EBaud57600   = CBR_57600,	// 57600 bits/sec
		EBaud115200  = CBR_115200,	// 115200 bits/sec
		EBaud128000  = CBR_128000,	// 128000 bits/sec
		EBaud256000  = CBR_256000,	// 256000 bits/sec

	}
	EBaudrate;

	// λ(5-8)
	typedef enum
	{
		EDataUnknown = -1,			// Unknown
		EData5       =  5,			// 5 bits per byte
		EData6       =  6,			// 6 bits per byte
		EData7       =  7,			// 7 bits per byte
		EData8       =  8			// 8 bits per byte (default)
	}
	EDataBits;

	// ż
	typedef enum
	{
		EParUnknown = -1,		// δ֪
		EParNone    = NOPARITY,		// У
		EParOdd     = ODDPARITY,	// У
		EParEven    = EVENPARITY,	// żУ
		EParMark    = MARKPARITY,	// У
		EParSpace   = SPACEPARITY	// ոУ
	}
	EParity;

	// ֹͣλ
	typedef enum
	{
		EStopUnknown = -1,		 // δ֪
		EStop1       = ONESTOPBIT,	// 1 stopbit (default)
		EStop1_5     = ONE5STOPBITS,    // 1.5 stopbit
		EStop2       = TWOSTOPBITS	// 2 stopbits
	}
	EStopBits;

	// ź
	typedef enum
	{
		EHandshakeUnknown		= -1,	// δ֪
		EHandshakeOff			=  0,	// 
		EHandshakeHardware		=  1,	// Ӳ
		EHandshakeSoftware		=  2	// 
	}
	EHandshake;

	// ʱ
	typedef enum
	{
		EReadTimeoutUnknown	 = -1,	// δ֪
		EReadTimeoutNonblocking	=  0,	// 
		EReadTimeoutBlocking	=  1	//
	}
	EReadTimeout;


	// ״̬
	typedef enum
	{
		EPortUnknownError = -1,		// Unknown error occurred
		EPortAvailable    =  0,		// Port is available
		EPortNotAvailable =  1,		// Port is not present
		EPortInUse        =  2		// Port is in use

	}
	EPort;


  //----------------------------------------------------------------------------
 public:
  //----------------------------------------------------------------------------
  int  OpenPort (int nDataBit=EData8,int nStopBit=EStop1,int nParity=EParNone);
  //----------------------------------------------------------------------------
  void  ClosePort (BOOL bR = TRUE);
  //----------------------------------------------------------------------------
  BOOL  SetCommBaud(int baud);
  //-----------------------------------------------------------------------------
  BOOL  SetCommPort(int port);
  //-----------------------------------------------------------------------------
  BOOL  SetFrameHead(int nHead);
 //-----------------------------------------------------------------------------
  int  SendOrder(BYTE* pOrderBuff,BYTE* pAckBuff,int nTimeOuts);
  //-----------------------------------------------------------------------------
  int  SendData(BYTE* pOrderBuff,BYTE* pAckBuff,int nSendLen,int nTimeOuts,
                                int nRcv,BYTE cEnd, BOOL bIfRcv);
  //-----------------------------------------------------------------------------
  int ReadBlock(BYTE* pAckBuff,int nLen,int nTimeOuts);
  //-----------------------------------------------------------------------------
  HANDLE GetCommHandle(void);
  //----------------------------------------------------------------------------
  BOOL SetDTR();
  //----------------------------------------------------------------------------
  BOOL ClrDTR();
  //----------------------------------------------------------------------------
  BOOL SetRTS();
  //----------------------------------------------------------------------------
  BOOL ClrRTS();
  //----------------------------------------------------------------------------
  int CommWatch(int &nLen,BYTE* pBuff);


private:

  int   Setup (EBaudrate eBaudrate = EBaud9600,
						EDataBits eDataBits = EData8,
						EParity   eParity= EParNone,
						EStopBits eStopBits =EStop1 );
  //----------------------------------------------------------------------------
   int  SetupReadTimeouts (int nBlockRead);
  //---------------------------------------------------------------------------
   int  SetMask (DWORD dwMask = EV_RXCHAR);
  //----------------------------------------------------------------------------
   int  Flush (void);
   //---------------------------------------------------------------------------
   int  Write (BYTE* pData, size_t iLen, DWORD* pdwWritten = 0, LPOVERLAPPED lpOverlapped = 0, DWORD dwTimeout = INFINITE);
  //----------------------------------------------------------------------------
   int  Read (BYTE* pData, size_t iLen, DWORD* pdwRead = 0, LPOVERLAPPED lpOverlapped = 0, DWORD dwTimeout = INFINITE);
  //-----------------------------------------------------------------------------
   int  WaitEvent (BYTE* Buff,int nTimeOuts);
  //----------------------------------------------------------------------------
   int Wait_Cnt(BYTE* Buff,int nTimeOuts,int nRcvCnt);
  //----------------------------------------------------------------------------
   int Wait_Byte(BYTE* Buff,int nTimeOuts,BYTE cEndByte);


private:
 	HANDLE	hComm;
	EEvent	m_eEvent;
        HANDLE	m_hevtOverlapped;
        int nFrameHead;
        DCB  m_dcb;
        LPCTSTR lpszPort;	//˿
        EBaudrate eBaudrates;	//
	int ErrorTimes;		//Error Thresholds
        int nFrameNum;          //ÿֽ֡ڸ
        int nTimePerByte;
  
};

